# JUN-CLI
### 更易上手的前端构建工具

![](https://cn.vuejs.org/images/logo.png)

![](https://img.shields.io/github/stars/pandao/editor.md.svg) ![](https://img.shields.io/github/forks/pandao/editor.md.svg) ![](https://img.shields.io/github/tag/pandao/editor.md.svg) ![](https://img.shields.io/github/release/pandao/editor.md.svg) ![](https://img.shields.io/github/issues/pandao/editor.md.svg) ![](https://img.shields.io/bower/v/editor.md.svg)




## 链接
- [WebPack](http://webpack.github.io/docs/)
- [Vue](https://cn.vuejs.org/)
- [Vuex](https://vuex.vuejs.org/)
- [Vue-Router](https://router.vuejs.org/)
- [Vue-Resource](https://github.com/pagekit/vue-resource)

## 讨论
使用上遇到的问题请联系 [作者邮箱](mailto:longjun.qu@cootek.cn), issue 仅仅用来处理 bug 和 feature 等的问题。

## 特性
- 简化 webpack 的配置，更人性化的配置参数
- 快速搭建项目且无需重复安装依赖，基于 webpack 2
- 集成通用组件，简化繁琐配置流程
- 生成的配置完全兼容 webpack 的命令行工具

## 安装

运行环境
- Node.js 4+
- npm 3+

## 集成工具

基础工具
- WebPack 1.13+
- Vue 2.0.3+

其他工具
- Vuex 2.0+
- Vue-Resource 1.2.1+
- Vue-Router 2.2.1+

开发工具
- JQuery 2.1.0+
- Bootstrap 3.3.7+


### 安装Node与包管理工具（基于Brew）
```shell
brew install node
```

Step 1. 创建一个项目文件夹 （将JUN-CLI Git Clone至本地）
```shell
$ mkdir vue-demo
$ cd vue-demo
$ git clone git@github.com:qulongjun/Jun-CLI.git .
```

Step 2. 开始开发
```shell
$ npm run dev
```

Step 3. 访问地址
```shell
$ http://localhost:8888
```

# License
[MIT](https://github.com/ElemeFE/cooking/LICENSE)

